<script setup lang="ts">
import { onMounted, reactive } from 'vue'
import { useDataStore } from '@/store/data'
import { Role } from '@/scripts/types'
import API from '@/scripts/api'

const props = defineProps({
  operatorMode: {
    type: Boolean,
    default: false
  }
})

const data = useDataStore()
const state = reactive({
  userEditDialog: false,
  loading: true,
  search: ''
})

const headers = [
  {
    title: 'Nom complet',
    align: 'start',
    key: 'display_name'
  },
  {
    title: 'Rôle',
    align: 'center',
    key: 'role'
  },
  {
    title: '',
    align: 'center',
    key: 'actions',
    sortable: false
  }
]

const operatorHeaders = [
  {
    title: 'SCIPER',
    align: 'center',
    key: 'sciper'
  },
  {
    title: 'Nom complet',
    align: 'start',
    key: 'display_name'
  },
  {
    title: 'Rôle',
    align: 'center',
    key: 'role'
  },
  {
    title: 'Présence',
    align: 'center',
    key: 'ticket_id'
  }
]

const roles: { name: string, role: Role }[] = [
  { name: 'Pas de rôle', role: null },
  { name: 'Opérateur', role: 'operator' },
  { name: 'Scrutateur', role: 'teller' },
  { name: 'Agent de présence', role: 'presence_agent' }]

onMounted(() => {
  refresh()
})

function persistRole(sciper: string, role: Role) {
  API.updateUserRole(sciper, role).finally(() => {
    data.refreshUsers()
  })
}

function refresh() {
  state.loading = true
  data.refreshUsers().finally(() => {
    state.loading = false
  })
}

</script>

<template>
  <div class="px-5">
    <v-data-table :headers="operatorMode ? operatorHeaders : headers" :items="data.users"
      :sort-by="[{ key: 'sciper', order: 'asc' }]" class="elevation-1" :loading="state.loading" :search="state.search">
      <template v-slot:top>
        <v-toolbar flat>
          <v-toolbar-title>Liste des utilisateurs</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <v-text-field density="compact" variant="solo" label="Recherche" append-inner-icon="mdi-magnify" single-line
            hide-details v-model="state.search" />
          <v-btn color="primary" @click="refresh" :loading="state.loading">
            Actualiser
          </v-btn>
        </v-toolbar>
      </template>

      <!--eslint-disable-next-line vue/valid-v-slot -->
      <template v-slot:item.sciper="{ item }">
        <div class="flex items-baseline">
          <p>{{ item.raw.sciper }}</p>
        </div>
      </template>

      <!--eslint-disable-next-line vue/valid-v-slot -->
      <template v-slot:item.display_name="{ item }">
        <div class="flex items-center">
          <v-btn class="mr-3" icon="mdi-account" :href="'https://people.epfl.ch/' + item.raw.sciper" target="_blank" size="x-small" />
          <p>
            <a :href="'https://people.epfl.ch/' + item.raw.sciper" target="_blank">{{ item.raw.display_name }}</a>
          </p>
        </div>
      </template>

      <!--eslint-disable-next-line vue/valid-v-slot -->
      <template v-slot:item.role="{ item }">
        <v-select v-if="props.operatorMode" class="min-w-[200px] mt-2" item-title="name" item-value="role"
          :items="roles" v-model="item.raw.role"
          @update:model-value="() => persistRole(item.raw.sciper, item.raw.role)"></v-select>
        <div v-else>
          <v-chip class="mx-1" label size="x-small" v-if="!item.raw.role">
            Pas de rôle
          </v-chip>
          <v-chip class="mx-1" label size="x-small" color="red" v-if="item.raw.role === 'operator'">
            Opérateur
          </v-chip>
          <v-chip class="mx-1" label size="x-small" color="orange" v-if="item.raw.role === 'teller'">
            Scrutateur
          </v-chip>
          <v-chip class="mx-1" label size="x-small" color="blue" v-if="item.raw.role === 'presence_agent'">
            Agent
          </v-chip>
        </div>
      </template>
    </v-data-table>
  </div>
</template>
